export interface IColor {
  red: number,
  green: number,
  blue: number,
  alpha: number,
}

export interface IColorEntry {
   value: number,
   color: IColor
}

export interface IHistogramEntry {
  value: number,
  freqency: number
}

export interface IHistogram {
  min: number,
  max: number,
  mean: number,
  stddev: number,
  classes: number,
  entries: IHistogramEntry[]
}

export interface IGradientstop {
  relativestop: number,
  color: IColor
}

export interface IColorMap {
  gradient: IGradientstop[],
  noValue: IColorEntry,
  entries: IColorEntry[],
  colormapType: string
}

export interface IBand {
  histogram: IHistogram
}


export interface IRenderer {
  band:IBand,
  colorMap: IColorMap
}

export interface IRenderoutput {
  renderoutputType: string
}

export interface IRenderoutputTiles {
  renderoutputType: string,
  minzoom: number,
  maxzoom: number
}

export interface IRenderoutputImage {
  renderoutputType: string,
  extent: [number,number,number,number]
}

export interface ILayer {
  name: string,
  unit: string,
  index: number,
  renderer: IRenderer,
  rendering: IRenderoutput
}
